Index: cpukit/rtems/src/semobtain.c
===================================================================
--- cpukit/rtems/src/semobtain.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/semobtain.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -22,4 +22,5 @@
 #include <rtems/rtems/attrimpl.h>
 #include <rtems/rtems/optionsimpl.h>
+#include <rtems/rtems/statusimpl.h>
 
 THREAD_QUEUE_OBJECT_ASSERT(
@@ -44,4 +45,5 @@
   rtems_attribute       attribute_set;
   bool                  wait;
+  Status_Control        status;
 
   the_semaphore = _Semaphore_Get( id, &queue_context, NULL );
@@ -60,7 +62,5 @@
 #if defined(RTEMS_SMP)
   if ( _Attributes_Is_multiprocessor_resource_sharing( attribute_set ) ) {
-    MRSP_Status mrsp_status;
-
-    mrsp_status = _MRSP_Seize(
+    status = _MRSP_Seize(
       &the_semaphore->Core_control.mrsp,
       executing,
@@ -69,9 +69,8 @@
       &queue_context
     );
-    return _Semaphore_Translate_MRSP_status_code( mrsp_status );
   } else
 #endif
   if ( !_Attributes_Is_counting_semaphore( attribute_set ) ) {
-    _CORE_mutex_Seize(
+    status = _CORE_mutex_Seize(
       &the_semaphore->Core_control.mutex,
       executing,
@@ -80,19 +79,15 @@
       &queue_context
     );
-    return _Semaphore_Translate_core_mutex_return_code(
-      executing->Wait.return_code
+  } else {
+    /* must be a counting semaphore */
+    status = _CORE_semaphore_Seize(
+      &the_semaphore->Core_control.semaphore,
+      executing,
+      wait,
+      timeout,
+      &queue_context
     );
   }
 
-  /* must be a counting semaphore */
-  _CORE_semaphore_Seize(
-    &the_semaphore->Core_control.semaphore,
-    executing,
-    wait,
-    timeout,
-    &queue_context
-  );
-  return _Semaphore_Translate_core_semaphore_return_code(
-    executing->Wait.return_code
-  );
+  return _Status_Get( status );
 }
Index: cpukit/rtems/src/semrelease.c
===================================================================
--- cpukit/rtems/src/semrelease.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/semrelease.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -24,12 +24,12 @@
 #include <rtems/rtems/semimpl.h>
 #include <rtems/rtems/attrimpl.h>
+#include <rtems/rtems/statusimpl.h>
 
 rtems_status_code rtems_semaphore_release( rtems_id id )
 {
-  Semaphore_Control     *the_semaphore;
-  CORE_mutex_Status      mutex_status;
-  CORE_semaphore_Status  semaphore_status;
-  rtems_attribute        attribute_set;
-  Thread_queue_Context   queue_context;
+  Semaphore_Control    *the_semaphore;
+  Thread_queue_Context  queue_context;
+  rtems_attribute       attribute_set;
+  Status_Control        status;
 
   the_semaphore = _Semaphore_Get(
@@ -50,27 +50,24 @@
 #if defined(RTEMS_SMP)
   if ( _Attributes_Is_multiprocessor_resource_sharing( attribute_set ) ) {
-    MRSP_Status mrsp_status;
-
-    mrsp_status = _MRSP_Surrender(
+    status = _MRSP_Surrender(
       &the_semaphore->Core_control.mrsp,
       _Thread_Executing,
       &queue_context
     );
-    return _Semaphore_Translate_MRSP_status_code( mrsp_status );
   } else
 #endif
   if ( !_Attributes_Is_counting_semaphore( attribute_set ) ) {
-    mutex_status = _CORE_mutex_Surrender(
+    status = _CORE_mutex_Surrender(
       &the_semaphore->Core_control.mutex,
       &queue_context
     );
-    return _Semaphore_Translate_core_mutex_return_code( mutex_status );
   } else {
-    semaphore_status = _CORE_semaphore_Surrender(
+    status = _CORE_semaphore_Surrender(
       &the_semaphore->Core_control.semaphore,
       UINT32_MAX,
       &queue_context
     );
-    return _Semaphore_Translate_core_semaphore_return_code( semaphore_status );
   }
+
+  return _Status_Get( status );
 }
Index: cpukit/rtems/src/signalmp.c
===================================================================
--- cpukit/rtems/src/signalmp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/signalmp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,4 +21,5 @@
 #include <rtems/rtems/signalimpl.h>
 #include <rtems/rtems/optionsimpl.h>
+#include <rtems/rtems/statusimpl.h>
 #include <rtems/score/statesimpl.h>
 #include <rtems/score/threadimpl.h>
@@ -72,4 +73,5 @@
 {
   Signal_MP_Packet *the_packet;
+  Status_Control    status;
 
   the_packet = _Signal_MP_Get_packet( id );
@@ -85,10 +87,10 @@
   the_packet->signal_set        = signal_set;
 
-  return (rtems_status_code) _MPCI_Send_request_packet(
+  status = _MPCI_Send_request_packet(
     _Objects_Get_node( id ),
     &the_packet->Prefix,
-    STATES_READY,
-    RTEMS_TIMEOUT
+    STATES_READY
   );
+  return _Status_Get( status );
 }
 
Index: cpukit/rtems/src/systemeventreceive.c
===================================================================
--- cpukit/rtems/src/systemeventreceive.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/systemeventreceive.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -50,5 +50,5 @@
 
     if ( !_Event_sets_Is_empty( event_in ) ) {
-      _Event_Seize(
+      sc = _Event_Seize(
         event_in,
         option_set,
@@ -61,6 +61,4 @@
         &lock_context
       );
-
-      sc = executing->Wait.return_code;
     } else {
       *event_out = event->pending_events;
Index: cpukit/rtems/src/taskmp.c
===================================================================
--- cpukit/rtems/src/taskmp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/taskmp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,4 +21,5 @@
 #include <rtems/rtems/tasksimpl.h>
 #include <rtems/rtems/optionsimpl.h>
+#include <rtems/rtems/statusimpl.h>
 #include <rtems/score/statesimpl.h>
 #include <rtems/score/threadimpl.h>
@@ -102,4 +103,6 @@
 )
 {
+  Status_Control status;
+
   the_packet->Prefix.the_class  = MP_PACKET_TASKS;
   the_packet->Prefix.length     = sizeof( *the_packet );
@@ -108,10 +111,10 @@
   the_packet->operation         = operation;
 
-  return _MPCI_Send_request_packet(
+  status = _MPCI_Send_request_packet(
     _Objects_Get_node( id ),
     &the_packet->Prefix,
-    STATES_READY,    /* Not used */
-    RTEMS_TIMEOUT
+    STATES_READY /* Not used */
   );
+  return _Status_Get( status );
 }
 
Index: cpukit/score/Makefile.am
===================================================================
--- cpukit/score/Makefile.am	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/Makefile.am	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -88,4 +88,5 @@
 include_rtems_score_HEADERS += include/rtems/score/states.h
 include_rtems_score_HEADERS += include/rtems/score/statesimpl.h
+include_rtems_score_HEADERS += include/rtems/score/status.h
 include_rtems_score_HEADERS += include/rtems/score/sysstate.h
 include_rtems_score_HEADERS += include/rtems/score/thread.h
Index: cpukit/score/include/rtems/score/corebarrierimpl.h
===================================================================
--- cpukit/score/include/rtems/score/corebarrierimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/corebarrierimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,4 +21,5 @@
 
 #include <rtems/score/corebarrier.h>
+#include <rtems/score/status.h>
 #include <rtems/score/threadqimpl.h>
 
@@ -31,33 +32,4 @@
  */
 /**@{**/
-
-/**
- *  Core Barrier handler return statuses.
- */
-typedef enum {
-  /** This status indicates that the operation completed successfully. */
-  CORE_BARRIER_STATUS_SUCCESSFUL,
-  /** This status indicates that the barrier is configured for automatic
-   *  release and the caller tripped the automatic release.  The caller
-   *  thus did not block.
-   */
-  CORE_BARRIER_STATUS_AUTOMATICALLY_RELEASED,
-  /** This status indicates that the thread was blocked waiting for an
-   *  operation to complete and the barrier was deleted.
-   */
-  CORE_BARRIER_WAS_DELETED,
-  /** This status indicates that the calling task was willing to block
-   *  but the operation was unable to complete within the time allotted
-   *  because the resource never became available.
-   */
-  CORE_BARRIER_TIMEOUT
-}   CORE_barrier_Status;
-
-/**
- *  @brief Core barrier last status value.
- *
- *  This is the last status value.
- */
-#define CORE_BARRIER_STATUS_LAST CORE_BARRIER_TIMEOUT
 
 #define CORE_BARRIER_TQ_OPERATIONS &_Thread_queue_Operations_FIFO
@@ -121,7 +93,7 @@
  *         thread unblocked is remote
  *
- * @note Status is returned via the thread control block.
+ * @return The method status.
  */
-void _CORE_barrier_Seize(
+Status_Control _CORE_barrier_Seize(
   CORE_barrier_Control *the_barrier,
   Thread_Control       *executing,
@@ -161,10 +133,4 @@
 }
 
-Thread_Control *_CORE_barrier_Was_deleted(
-  Thread_Control       *the_thread,
-  Thread_queue_Queue   *queue,
-  Thread_queue_Context *queue_context
-);
-
 RTEMS_INLINE_ROUTINE void _CORE_barrier_Flush(
   CORE_barrier_Control *the_barrier,
@@ -174,5 +140,5 @@
   _CORE_barrier_Do_flush(
     the_barrier,
-    _CORE_barrier_Was_deleted,
+    _Thread_queue_Flush_status_object_was_deleted,
     queue_context
   );
Index: cpukit/score/include/rtems/score/coremsgimpl.h
===================================================================
--- cpukit/score/include/rtems/score/coremsgimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/coremsgimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,4 +21,5 @@
 
 #include <rtems/score/coremsg.h>
+#include <rtems/score/status.h>
 #include <rtems/score/chainimpl.h>
 #include <rtems/score/threaddispatch.h>
@@ -64,38 +65,4 @@
  */
 typedef int CORE_message_queue_Submit_types;
-
-/**
- *  @brief The possible set of Core Message Queue handler return statuses.
- *
- *  This enumerated type defines the possible set of Core Message
- *  Queue handler return statuses.
- */
-typedef enum {
-  /** This value indicates the operation completed sucessfully. */
-  CORE_MESSAGE_QUEUE_STATUS_SUCCESSFUL,
-  /** This value indicates that the message was too large for this queue. */
-  CORE_MESSAGE_QUEUE_STATUS_INVALID_SIZE,
-  /** This value indicates that there are too many messages pending. */
-  CORE_MESSAGE_QUEUE_STATUS_TOO_MANY,
-  /** This value indicates that a receive was unsuccessful. */
-  CORE_MESSAGE_QUEUE_STATUS_UNSATISFIED,
-  /** This value indicates that a blocking send was unsuccessful. */
-  CORE_MESSAGE_QUEUE_STATUS_UNSATISFIED_NOWAIT,
-  /** This value indicates that the message queue being blocked upon
-   *  was deleted while the thread was waiting.
-   */
-  CORE_MESSAGE_QUEUE_STATUS_WAS_DELETED,
-  /** This value indicates that the thread had to timeout while waiting
-   *  to receive a message because one did not become available.
-   */
-  CORE_MESSAGE_QUEUE_STATUS_TIMEOUT,
-}   CORE_message_queue_Status;
-
-/**
- *  @brief Core message queue last status value.
- *
- *  This is the last status value.
- */
-#define CORE_MESSAGE_QUEUE_STATUS_LAST CORE_MESSAGE_QUEUE_STATUS_TIMEOUT
 
 /**
@@ -203,5 +170,5 @@
  *  @retval indication of the successful completion or reason for failure
  */
-CORE_message_queue_Status _CORE_message_queue_Broadcast(
+Status_Control _CORE_message_queue_Broadcast(
   CORE_message_queue_Control *the_message_queue,
   const void                 *buffer,
@@ -234,5 +201,5 @@
  *  @retval indication of the successful completion or reason for failure
  */
-CORE_message_queue_Status _CORE_message_queue_Submit(
+Status_Control _CORE_message_queue_Submit(
   CORE_message_queue_Control       *the_message_queue,
   Thread_Control                   *executing,
@@ -279,5 +246,5 @@
  *    + wait
  */
-void _CORE_message_queue_Seize(
+Status_Control _CORE_message_queue_Seize(
   CORE_message_queue_Control *the_message_queue,
   Thread_Control             *executing,
@@ -310,5 +277,5 @@
 );
 
-RTEMS_INLINE_ROUTINE CORE_message_queue_Status _CORE_message_queue_Send(
+RTEMS_INLINE_ROUTINE Status_Control _CORE_message_queue_Send(
   CORE_message_queue_Control       *the_message_queue,
   const void                       *buffer,
@@ -331,5 +298,5 @@
 }
 
-RTEMS_INLINE_ROUTINE CORE_message_queue_Status _CORE_message_queue_Urgent(
+RTEMS_INLINE_ROUTINE Status_Control _CORE_message_queue_Urgent(
   CORE_message_queue_Control       *the_message_queue,
   const void                       *buffer,
Index: cpukit/score/include/rtems/score/coremuteximpl.h
===================================================================
--- cpukit/score/include/rtems/score/coremuteximpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/coremuteximpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,4 +21,5 @@
 #include <rtems/score/coremutex.h>
 #include <rtems/score/chainimpl.h>
+#include <rtems/score/status.h>
 #include <rtems/score/sysstate.h>
 #include <rtems/score/threadimpl.h>
@@ -33,51 +34,4 @@
  */
 /**@{**/
-
-/**
- *  @brief The possible Mutex handler return statuses.
- *
- *  This enumerated type defines the possible Mutex handler return statuses.
- */
-typedef enum {
-  /** This status indicates that the operation completed successfully. */
-  CORE_MUTEX_STATUS_SUCCESSFUL,
-  /** This status indicates that the calling task did not want to block
-   *  and the operation was unable to complete immediately because the
-   *  resource was unavailable.
-   */
-  CORE_MUTEX_STATUS_UNSATISFIED_NOWAIT,
-#if defined(RTEMS_POSIX_API)
-  /** This status indicates that an attempt was made to relock a mutex
-   *  for which nesting is not configured.
-   */
-  CORE_MUTEX_STATUS_NESTING_NOT_ALLOWED,
-#endif
-  /** This status indicates that an attempt was made to release a mutex
-   *  by a thread other than the thread which locked it.
-   */
-  CORE_MUTEX_STATUS_NOT_OWNER_OF_RESOURCE,
-  /** This status indicates that the thread was blocked waiting for an
-   *  operation to complete and the mutex was deleted.
-   */
-  CORE_MUTEX_WAS_DELETED,
-  /** This status indicates that the calling task was willing to block
-   *  but the operation was unable to complete within the time allotted
-   *  because the resource never became available.
-   */
-  CORE_MUTEX_TIMEOUT,
-
-  /** This status indicates that a thread of logically greater importance
-   *  than the ceiling priority attempted to lock this mutex.
-   */
-  CORE_MUTEX_STATUS_CEILING_VIOLATED
-
-}   CORE_mutex_Status;
-
-/**
- *  @brief The last status value.
- *
- *  This is the last status value.
- */
-#define CORE_MUTEX_STATUS_LAST CORE_MUTEX_STATUS_CEILING_VIOLATED
 
 /**
@@ -93,7 +47,7 @@
  *  the executing thread.
  *
- *  @retval This method returns CORE_MUTEX_STATUS_SUCCESSFUL if successful.
- */
-CORE_mutex_Status _CORE_mutex_Initialize(
+ *  @retval This method returns STATUS_SUCCESSFUL if successful.
+ */
+Status_Control _CORE_mutex_Initialize(
   CORE_mutex_Control           *the_mutex,
   Thread_Control               *executing,
@@ -141,5 +95,5 @@
  *  @param[in] lock_context is the interrupt level
  */
-void _CORE_mutex_Seize_interrupt_blocking(
+Status_Control _CORE_mutex_Seize_interrupt_blocking(
   CORE_mutex_Control  *the_mutex,
   Thread_Control      *executing,
@@ -228,10 +182,8 @@
  *  @param[in] queue_context is the interrupt level
  *
- *  @retval This routine returns 0 if "trylock" can resolve whether or not
- *  the mutex is immediately obtained or there was an error attempting to
- *  get it.  It returns 1 to indicate that the caller cannot obtain
- *  the mutex and will have to block to do so.
- */
-RTEMS_INLINE_ROUTINE int _CORE_mutex_Seize_interrupt_trylock(
+ *  @retval STATUS_UNAVAILABLE The mutex is already locked.
+ *  @retval other Otherwise.
+ */
+RTEMS_INLINE_ROUTINE Status_Control _CORE_mutex_Seize_interrupt_trylock(
   CORE_mutex_Control   *the_mutex,
   Thread_Control       *executing,
@@ -241,5 +193,4 @@
   /* disabled when you get here */
 
-  executing->Wait.return_code = CORE_MUTEX_STATUS_SUCCESSFUL;
   if ( !_CORE_mutex_Is_locked( the_mutex ) ) {
     the_mutex->holder     = executing;
@@ -252,11 +203,11 @@
     if ( !_CORE_mutex_Is_priority_ceiling( &the_mutex->Attributes ) ) {
       _CORE_mutex_Release( the_mutex, queue_context );
-      return 0;
-    } /* else must be CORE_MUTEX_DISCIPLINES_PRIORITY_CEILING
+    } else {
+      /*
+       * must be CORE_MUTEX_DISCIPLINES_PRIORITY_CEILING
        *
        * we possibly bump the priority of the current holder -- which
        * happens to be _Thread_Executing.
        */
-    {
       Priority_Control  ceiling;
       Priority_Control  current;
@@ -266,8 +217,5 @@
       if ( current == ceiling ) {
         _CORE_mutex_Release( the_mutex, queue_context );
-        return 0;
-      }
-
-      if ( current > ceiling ) {
+      } else if ( current > ceiling ) {
         Per_CPU_Control *cpu_self;
 
@@ -278,16 +226,14 @@
         _Thread_Raise_priority( executing, ceiling );
         _Thread_Dispatch_enable( cpu_self );
-        return 0;
-      }
-      /* if ( current < ceiling ) */ {
-        executing->Wait.return_code = CORE_MUTEX_STATUS_CEILING_VIOLATED;
+      } else /* if ( current < ceiling ) */ {
         the_mutex->holder = NULL;
         the_mutex->nest_count = 0;     /* undo locking above */
         executing->resource_count--;   /* undo locking above */
         _CORE_mutex_Release( the_mutex, queue_context );
-        return 0;
+        return STATUS_MUTEX_CEILING_VIOLATED;
       }
     }
-    return 0;
+
+    return STATUS_SUCCESSFUL;
   }
 
@@ -302,10 +248,9 @@
         the_mutex->nest_count++;
         _CORE_mutex_Release( the_mutex, queue_context );
-        return 0;
+        return STATUS_SUCCESSFUL;
       #if defined(RTEMS_POSIX_API)
         case CORE_MUTEX_NESTING_IS_ERROR:
-          executing->Wait.return_code = CORE_MUTEX_STATUS_NESTING_NOT_ALLOWED;
           _CORE_mutex_Release( the_mutex, queue_context );
-          return 0;
+          return STATUS_NESTING_NOT_ALLOWED;
       #endif
       case CORE_MUTEX_NESTING_BLOCKS:
@@ -318,5 +263,5 @@
    *  of blocking.
    */
-  return 1;
+  return STATUS_UNAVAILABLE;
 }
 
@@ -347,5 +292,5 @@
  *      then they are blocked.
  */
-RTEMS_INLINE_ROUTINE void _CORE_mutex_Seize(
+RTEMS_INLINE_ROUTINE Status_Control _CORE_mutex_Seize(
   CORE_mutex_Control   *the_mutex,
   Thread_Control       *executing,
@@ -355,4 +300,6 @@
 )
 {
+  Status_Control status;
+
   if ( _CORE_mutex_Check_dispatch_for_seize( wait ) ) {
     _Terminate(
@@ -362,37 +309,32 @@
     );
   }
+
   _CORE_mutex_Acquire_critical( the_mutex, queue_context );
-  if (
-    _CORE_mutex_Seize_interrupt_trylock( the_mutex, executing, queue_context )
-  ) {
-    if ( !wait ) {
-      _CORE_mutex_Release( the_mutex, queue_context );
-      executing->Wait.return_code =
-        CORE_MUTEX_STATUS_UNSATISFIED_NOWAIT;
-    } else {
-      _CORE_mutex_Seize_interrupt_blocking(
-        the_mutex,
-        executing,
-        timeout,
-        &queue_context->Lock_context
-      );
-    }
-  }
-}
-
-CORE_mutex_Status _CORE_mutex_Surrender(
-  CORE_mutex_Control   *the_mutex,
-  Thread_queue_Context *queue_context
-);
-
-Thread_Control *_CORE_mutex_Was_deleted(
-  Thread_Control       *the_thread,
-  Thread_queue_Queue   *queue,
-  Thread_queue_Context *queue_context
-);
-
-Thread_Control *_CORE_mutex_Unsatisfied_nowait(
-  Thread_Control       *the_thread,
-  Thread_queue_Queue   *queue,
+
+  status = _CORE_mutex_Seize_interrupt_trylock(
+    the_mutex,
+    executing,
+    queue_context
+  );
+
+  if ( status != STATUS_UNAVAILABLE ) {
+    return status;
+  }
+
+  if ( !wait ) {
+    _CORE_mutex_Release( the_mutex, queue_context );
+    return status;
+  }
+
+  return _CORE_mutex_Seize_interrupt_blocking(
+    the_mutex,
+    executing,
+    timeout,
+    &queue_context->Lock_context
+  );
+}
+
+Status_Control _CORE_mutex_Surrender(
+  CORE_mutex_Control   *the_mutex,
   Thread_queue_Context *queue_context
 );
Index: cpukit/score/include/rtems/score/corerwlockimpl.h
===================================================================
--- cpukit/score/include/rtems/score/corerwlockimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/corerwlockimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -23,4 +23,5 @@
 #include <rtems/score/thread.h>
 #include <rtems/score/threadqimpl.h>
+#include <rtems/score/status.h>
 #include <rtems/score/watchdog.h>
 
@@ -35,25 +36,4 @@
 
 #define CORE_RWLOCK_TQ_OPERATIONS &_Thread_queue_Operations_FIFO
-
-/**
- *  Core RWLock handler return statuses.
- */
-typedef enum {
-  /** This status indicates that the operation completed successfully. */
-  CORE_RWLOCK_SUCCESSFUL,
-  /** This status indicates that the thread was blocked waiting for an */
-  CORE_RWLOCK_WAS_DELETED,
-  /** This status indicates that the rwlock was not immediately available. */
-  CORE_RWLOCK_UNAVAILABLE,
-  /** This status indicates that the calling task was willing to block
-   *  but the operation was unable to complete within the time allotted
-   *  because the resource never became available.
-   */
-  CORE_RWLOCK_TIMEOUT
-}   CORE_RWLock_Status;
-
-/** This is the last status value.
- */
-#define CORE_RWLOCK_STATUS_LAST CORE_RWLOCK_TIMEOUT
 
 /**
@@ -118,9 +98,7 @@
  *  @param[in] timeout is the number of ticks the calling thread is willing
  *         to wait if @a wait is true.
- *
- * @note Status is returned via the thread control block.
  */
 
-void _CORE_RWLock_Seize_for_reading(
+Status_Control _CORE_RWLock_Seize_for_reading(
   CORE_RWLock_Control  *the_rwlock,
   Thread_Control       *executing,
@@ -139,8 +117,6 @@
  *  @param[in] timeout is the number of ticks the calling thread is willing
  *         to wait if @a wait is true.
- *
- * @note Status is returned via the thread control block.
  */
-void _CORE_RWLock_Seize_for_writing(
+Status_Control _CORE_RWLock_Seize_for_writing(
   CORE_RWLock_Control  *the_rwlock,
   Thread_Control       *executing,
@@ -160,5 +136,5 @@
  *  @retval Status is returned to indicate successful or failure.
  */
-CORE_RWLock_Status _CORE_RWLock_Surrender(
+Status_Control _CORE_RWLock_Surrender(
   CORE_RWLock_Control  *the_rwlock,
   Thread_queue_Context *queue_context
Index: cpukit/score/include/rtems/score/coresemimpl.h
===================================================================
--- cpukit/score/include/rtems/score/coresemimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/coresemimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -23,6 +23,8 @@
 #include <rtems/score/objectimpl.h>
 #include <rtems/score/threaddispatch.h>
+#include <rtems/score/threadimpl.h>
 #include <rtems/score/threadqimpl.h>
 #include <rtems/score/statesimpl.h>
+#include <rtems/score/status.h>
 
 #ifdef __cplusplus
@@ -34,37 +36,4 @@
  */
 /**@{**/
-
-/**
- *  Core Semaphore handler return statuses.
- */
-typedef enum {
-  /** This status indicates that the operation completed successfully. */
-  CORE_SEMAPHORE_STATUS_SUCCESSFUL,
-  /** This status indicates that the calling task did not want to block
-   *  and the operation was unable to complete immediately because the
-   *  resource was unavailable.
-   */
-  CORE_SEMAPHORE_STATUS_UNSATISFIED_NOWAIT,
-  /** This status indicates that the thread was blocked waiting for an
-   *  operation to complete and the semaphore was deleted.
-   */
-  CORE_SEMAPHORE_WAS_DELETED,
-  /** This status indicates that the calling task was willing to block
-   *  but the operation was unable to complete within the time allotted
-   *  because the resource never became available.
-   */
-  CORE_SEMAPHORE_TIMEOUT,
-  /** This status indicates that an attempt was made to unlock the semaphore
-   *  and this would have made its count greater than that allowed.
-   */
-  CORE_SEMAPHORE_MAXIMUM_COUNT_EXCEEDED
-}   CORE_semaphore_Status;
-
-/**
- *  @brief Core semaphore last status value.
- *
- *  This is the last status value.
- */
-#define CORE_SEMAPHORE_STATUS_LAST CORE_SEMAPHORE_MAXIMUM_COUNT_EXCEEDED
 
 /**
@@ -109,16 +78,4 @@
 }
 
-Thread_Control *_CORE_semaphore_Was_deleted(
-  Thread_Control       *the_thread,
-  Thread_queue_Queue   *queue,
-  Thread_queue_Context *queue_context
-);
-
-Thread_Control *_CORE_semaphore_Unsatisfied_nowait(
-  Thread_Control       *the_thread,
-  Thread_queue_Queue   *queue,
-  Thread_queue_Context *queue_context
-);
-
 RTEMS_INLINE_ROUTINE void _CORE_semaphore_Destroy(
   CORE_semaphore_Control *the_semaphore,
@@ -129,5 +86,5 @@
     &the_semaphore->Wait_queue.Queue,
     the_semaphore->operations,
-    _CORE_semaphore_Was_deleted,
+    _Thread_queue_Flush_status_object_was_deleted,
     queue_context
   );
@@ -148,5 +105,5 @@
  *  @retval an indication of whether the routine succeeded or failed
  */
-RTEMS_INLINE_ROUTINE CORE_semaphore_Status _CORE_semaphore_Surrender(
+RTEMS_INLINE_ROUTINE Status_Control _CORE_semaphore_Surrender(
   CORE_semaphore_Control  *the_semaphore,
   uint32_t                 maximum_count,
@@ -155,7 +112,7 @@
 {
   Thread_Control *the_thread;
-  CORE_semaphore_Status status;
-
-  status = CORE_SEMAPHORE_STATUS_SUCCESSFUL;
+  Status_Control  status;
+
+  status = STATUS_SUCCESSFUL;
 
   _CORE_semaphore_Acquire_critical( the_semaphore, queue_context );
@@ -176,5 +133,5 @@
       the_semaphore->count += 1;
     else
-      status = CORE_SEMAPHORE_MAXIMUM_COUNT_EXCEEDED;
+      status = STATUS_MAXIMUM_COUNT_EXCEEDED;
 
     _CORE_semaphore_Release( the_semaphore, queue_context );
@@ -192,5 +149,5 @@
     &the_semaphore->Wait_queue.Queue,
     the_semaphore->operations,
-    _CORE_semaphore_Unsatisfied_nowait,
+    _Thread_queue_Flush_status_unavailable,
     queue_context
   );
@@ -226,5 +183,5 @@
  * @note There is currently no MACRO version of this routine.
  */
-RTEMS_INLINE_ROUTINE void _CORE_semaphore_Seize(
+RTEMS_INLINE_ROUTINE Status_Control _CORE_semaphore_Seize(
   CORE_semaphore_Control *the_semaphore,
   Thread_Control         *executing,
@@ -236,16 +193,14 @@
   /* disabled when you get here */
 
-  executing->Wait.return_code = CORE_SEMAPHORE_STATUS_SUCCESSFUL;
   _CORE_semaphore_Acquire_critical( the_semaphore, queue_context );
   if ( the_semaphore->count != 0 ) {
     the_semaphore->count -= 1;
     _CORE_semaphore_Release( the_semaphore, queue_context );
-    return;
+    return STATUS_SUCCESSFUL;
   }
 
   if ( !wait ) {
     _CORE_semaphore_Release( the_semaphore, queue_context );
-    executing->Wait.return_code = CORE_SEMAPHORE_STATUS_UNSATISFIED_NOWAIT;
-    return;
+    return STATUS_UNSATISFIED;
   }
 
@@ -256,7 +211,7 @@
     STATES_WAITING_FOR_SEMAPHORE,
     timeout,
-    CORE_SEMAPHORE_TIMEOUT,
     &queue_context->Lock_context
   );
+  return _Thread_Wait_get_status( executing );
 }
 
Index: cpukit/score/include/rtems/score/corespinlockimpl.h
===================================================================
--- cpukit/score/include/rtems/score/corespinlockimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/corespinlockimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,4 +21,5 @@
 
 #include <rtems/score/corespinlock.h>
+#include <rtems/score/status.h>
 #include <rtems/score/watchdog.h>
 
@@ -33,35 +34,4 @@
  */
 /**@{**/
-
-/**
- *  Core Spinlock handler return statuses.
- */
-typedef enum {
-  /** This status indicates that the operation completed successfully. */
-  CORE_SPINLOCK_SUCCESSFUL,
-  /** This status indicates that the current thread already holds the spinlock.
-   *  An attempt to relock it will result in deadlock.
-   */
-  CORE_SPINLOCK_HOLDER_RELOCKING,
-  /** This status indicates that the current thread is attempting to unlock a
-   *  spinlock that is held by another thread.
-   */
-  CORE_SPINLOCK_NOT_HOLDER,
-  /** This status indicates that a thread reached the limit of time it
-   *  was willing to wait on the spin lock.
-   */
-  CORE_SPINLOCK_TIMEOUT,
-  /** This status indicates that a thread is currently waiting for this
-   *  spin lock.
-   */
-  CORE_SPINLOCK_IS_BUSY,
-  /** This status indicates that the spinlock is currently locked and thus
-   *  unavailable.
-   */
-  CORE_SPINLOCK_UNAVAILABLE
-}   CORE_spinlock_Status;
-
-/** This is a shorthand for the last status code. */
-#define CORE_SPINLOCK_STATUS_LAST CORE_SPINLOCK_UNAVAILABLE
 
 /** This indicates the lock is available. */
@@ -116,5 +86,5 @@
  *         this operation.
  */
-CORE_spinlock_Status _CORE_spinlock_Seize(
+Status_Control _CORE_spinlock_Seize(
   CORE_spinlock_Control *the_spinlock,
   bool                   wait,
@@ -131,5 +101,5 @@
  *  @param[in] the_spinlock is the spinlock to surrender
  */
-CORE_spinlock_Status _CORE_spinlock_Surrender(
+Status_Control _CORE_spinlock_Surrender(
   CORE_spinlock_Control *the_spinlock,
   ISR_lock_Context      *lock_context
Index: cpukit/score/include/rtems/score/mpciimpl.h
===================================================================
--- cpukit/score/include/rtems/score/mpciimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/mpciimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/score/mpci.h>
+#include <rtems/score/status.h>
 
 #ifdef __cplusplus
@@ -163,13 +164,11 @@
  *             may indicate the caller is blocking on a message queue
  *             operation.
- *  @param[in] timeout_code is the timeout code
  *
  *  @retval This method returns the operation status from the remote node.
  */
-uint32_t _MPCI_Send_request_packet (
-  uint32_t           destination,
-  MP_packet_Prefix  *the_packet,
-  States_Control     extra_state,
-  uint32_t           timeout_code
+Status_Control _MPCI_Send_request_packet(
+  uint32_t          destination,
+  MP_packet_Prefix *the_packet,
+  States_Control    extra_state
 );
 
Index: cpukit/score/include/rtems/score/mrsp.h
===================================================================
--- cpukit/score/include/rtems/score/mrsp.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/mrsp.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -52,29 +52,4 @@
  */
 
-/**
- * @brief MrsP status code.
- *
- * The values are chosen to directly map to RTEMS status codes.  In case this
- * implementation is used for other APIs, then for example the errno values can
- * be added with a bit shift.
- */
-typedef enum {
-  MRSP_SUCCESSFUL = 0,
-  MRSP_TIMEOUT = 6,
-  MRSP_INVALID_NUMBER = 10,
-  MRSP_RESOUCE_IN_USE = 12,
-  MRSP_UNSATISFIED = 13,
-  MRSP_INCORRECT_STATE = 14,
-  MRSP_INVALID_PRIORITY = 19,
-  MRSP_NOT_OWNER_OF_RESOURCE = 23,
-  MRSP_NO_MEMORY = 26,
-
-  /**
-   * @brief Internal state used for MRSP_Rival::status to indicate that this
-   * rival waits for resource ownership.
-   */
-  MRSP_WAIT_FOR_OWNERSHIP = 255
-} MRSP_Status;
-
 typedef struct MRSP_Control MRSP_Control;
 
@@ -125,8 +100,8 @@
    *
    * Initially the status is set to MRSP_WAIT_FOR_OWNERSHIP.  The rival will
-   * busy wait until a status change happens.  This can be MRSP_SUCCESSFUL or
-   * MRSP_TIMEOUT.  State changes are protected by the MrsP control lock.
+   * busy wait until a status change happens.  This can be STATUS_SUCCESSFUL or
+   * STATUS_TIMEOUT.  State changes are protected by the MrsP control lock.
    */
-  volatile MRSP_Status status;
+  volatile int status;
 
   /**
